Subject: Re: [nfsv4] Draft RFC for ONC RPC over AF_VSOCK

From: Stefan Hajnoczi <[email-masked]>
Date: Tue, 7 Nov 2017 11:32:10 +0000

On Fri, Oct 27, 2017 at 02:23:18PM +0100, Daniel P. Berrange wrote:
> On Fri, Oct 27, 2017 at 09:16:42AM -0400, Jeff Layton wrote:
> > On Thu, 2017-10-05 at 16:50 -0400, Matt Benjamin wrote:
> > > Hi Stefan,
> > > 
> > > On Thu, Oct 5, 2017 at 4:08 PM, Stefan Hajnoczi <[email-masked]> wrote:
> > > > I have previously submitted patches that implement NFS client and nfsd
> > > > support for the AF_VSOCK address family.  In order for this to be
> > > > acceptable for merge the AF_VSOCK transport needs to be defined in an
> > > > IETF RFC.  Below is a draft RFC that defines ONC RPC over AF_VSOCK.
> > > > 
> > > > My patches use netid "vsock" but "tcpv" has also been suggested.  This draft
> > > > RFC still uses "vsock" but I'll update it to "tcpv" if there is consensus.
> > > > 
> > > 
> > > I think "vsock" is the appropriate netid, not "tcpv."  Stream
> > > orientation, if anything, is the general category containing TCP and
> > > VSOCK, not the reverse.  But really I think it's just more clear.
> > > 
> > 
> > Agreed. VSOCK is its own thing. It bears some resemblance to TCP, but
> > calling it tcpv would be confusing. IIRC, Chuck only proposed that when
> > we were discussing an alternative transport that would look more like a
> > typical network.
> > 
> > BTW: Does VSOCK have a connectionless mode, analogous to UDP? If so,
> > then it may be nice to consider what the netid for that might look like
> > as well, before we settle on any names.
> 
> Yes, you can use SOCK_STREAM or SOCK_DGRAM when using vsock.

VMware has implemented both SOCK_STREAM and SOCK_DGRAM.

The virtio-vsock and Hyper-V drivers implement only SOCK_STREAM at the
moment.  In the future they may support SOCK_DGRAM if there are use
cases.

Stefan